%{

/*
   pikts.l -- PIKT filter utility for stripping away all comments

   $Header: /home/cvs/ucgsb/pikt/src/piktc/pikts.l,v 1.5 1999/04/10 20:35:05 berto Exp $

   This file is part of PIKT ("Problem Informant/Killer Tool").
   Copyright (C) 1998-99 by Robert Osterlund.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   PIKT is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
   USA.

   This product includes software developed by the University of
   California, Berkeley and its contributors.

   Send problem reports, bouquets and brickbats to:

   robert.osterlund@gsb.uchicago.edu

   Robert Osterlund
   Graduate School of Business
   University of Chicago
   1101 E. 58th Street, W309
   Chicago, IL 60637
   USA
 */

#include <stdio.h>
#include <stdlib.h>

#include "common.h"

const char pikts_version[] = "PIKT pikts version " VERSION;

int piktslex(void);

%}

W	[ \t]

%x CMNT0 CMNT1

%option noyywrap

%%

<INITIAL>("\\/*"|"/\\*"|"\\/\\*") { printf("/*"); }
<INITIAL>("\\*/"|"*\\/"|"\\*\\/") { printf("*/"); }
<INITIAL>("\\//"|"/\\/"|"\\/\\/") { printf("//"); }

<CMNT0,CMNT1>("\\/*"|"/\\*"|"\\/\\*") { ; }
<CMNT0,CMNT1>("\\*/"|"*\\/"|"\\*\\/") { ; }
<CMNT0,CMNT1>("\\//"|"/\\/"|"\\/\\/") { ; }

"/*"				{ BEGIN(CMNT0); }
{W}*"//"			{ BEGIN(CMNT1); }
\n				{ ECHO; }
.				{ ECHO; }

<CMNT0>"*/"			{ BEGIN(INITIAL); }
<CMNT0>\n			{ ECHO; }
<CMNT0>.			{ ; }

<CMNT1>.+			{ ; }
<CMNT1>\n			{ BEGIN(INITIAL);
				  ECHO;
				}

%%

int
main (void)
{
	piktslex();
	exit(0);
}
