/*
   piktc.x -- PIKT piktc & piktc_svc RPCL infile

   $Header: /home/cvs/ucgsb/pikt/src/piktc/rpc.x,v 1.4 1999/05/09 18:39:49 berto Exp $

   This file is part of PIKT ("Problem Informant/Killer Tool").
   Copyright (C) 1998-99 by Robert Osterlund.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   PIKT is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
   USA.

   This product includes software developed by the University of
   California, Berkeley and its contributors.

   Send problem reports, bouquets and brickbats to:

   robert.osterlund@gsb.uchicago.edu

   Robert Osterlund
   Graduate School of Business
   University of Chicago
   1101 E. 58th Street, W309
   Chicago, IL 60637
   USA
 */

typedef string nametype<>;
typedef string dirtype<>;
typedef string exttype<>;
typedef string modetype<>;
typedef string uidtype<>;
typedef string gidtype<>;
typedef string buftype<>;

struct _rfil {
	nametype name;
	dirtype directory;
	exttype extension;
	modetype mode;
	uidtype uid;
	gidtype gid;
	int size;
	buftype text;
};

typedef struct _rfil rfil;

struct _anam {
	nametype name;
	buftype aux;		/* only used by alerts */
	int state;
	struct _anam *next;
};

typedef struct _anam anam;

program PIKTCPROG {
	version PIKTCVERS {
		int FILEEXIST(rfil)		= 1;
		int INSTALLFILE(rfil)		= 2;
		int DELETEFILE(rfil)		= 3;
		int EDITCONF(anam)		= 4;
		int KILLPIKTD(void)		= 5;
		int KILLPIKTC_SVC(void)		= 6;
		int RESTARTPIKTD(void)		= 7;
		int RESTARTPIKTC_SVC(void)	= 8;
		int SHOWSTATUS(anam)		= 9;
	} = 1;
} = RPCPRGNUM;
