%{

/*
   sys.y -- PIKT piktc parser for the systems.cfg file

   $Header: /home/cvs/ucgsb/pikt/src/piktc/sys.y,v 1.4 1999/04/10 20:35:06 berto Exp $

   This file is part of PIKT ("Problem Informant/Killer Tool").
   Copyright (C) 1998-99 by Robert Osterlund.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   PIKT is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
   USA.

   This product includes software developed by the University of
   California, Berkeley and its contributors.

   Send problem reports, bouquets and brickbats to:

   robert.osterlund@gsb.uchicago.edu

   Robert Osterlund
   Graduate School of Business
   University of Chicago
   1101 E. 58th Street, W309
   Chicago, IL 60637
   USA
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "common.h"

%}

%union {
	char *sval;
}

%token <sval> _STANZA _HOST
%token _HOSTS _MEMBERS _ALIASES

%%

start:		systems 
		| systems aliases
		| systems groups
		| systems aliases groups
		;

systems:	system
		| systems system
		;

aliases:	alias
		| aliases alias
		;

groups:		group
		| groups group
		;

system:		_STANZA {
			if (!prescan)
				regident($1, OPS, FALSE);
			else
				opsysnum++;
		}
		_HOSTS
		syshosts 
		;

alias:		_STANZA {
			if (!prescan)
				hostcurr = $1;
		}
		_ALIASES
		alshosts {
			if (!prescan)
				free($1);
		}
		;

group:		_STANZA {
			if (!prescan)
				regident($1, GRP, FALSE);
		}
		_MEMBERS
		grphosts
		;

syshosts:	syshost
		| syshosts syshost

alshosts:	alshost
		| alshosts alshost
		;

grphosts:	grphost
		| grphosts grphost

syshost:	_HOST {
			if (!prescan) {
				regident($1, HST, FALSE);
				insert($1, HST);
			} else
				hostnum++;
		}

alshost:	_HOST {
			if (!prescan)
				regident($1, ALS, FALSE);
		}

grphost:	_HOST {
			if (!prescan) {
				if ((hostcurr = alias($1)))
					insert(hostcurr, HST);
				/* else error message already print in
				   alias()
				 */
			}
		}

%%
